<script>
    let default_nft_full = {
        id: '',
        names: {},
        objects: []
    };

    export /**
     * @type {any}
     */
    let nft_full;

    //if nft data is null, use default type
    if (!nft_full) {
        nft_full = default_nft_full;
    }

    let default_token_uri = {
        name: '',
        created_by: '',
        description: ''
    };

    function parseJson(json_string) {
        try {
            return JSON.parse(json_string);
        } catch (e) {
            return '';
        }
    }

    /**
     * @param {string} id
     */
    export function id_or_name(id) {
        return id in nft_full.names ? nft_full.names[id] : id;
    }
    export function id_or_name_link(id) {
        return '/u/' + (id in nft_full.names ? nft_full.names[id] : id.split('.')[2]);
    }

    //parse nft_id
    let nft_id = nft_full.id;
    let nft_obj =
        'objects' in nft_full && nft_id in nft_full.objects ? nft_full.objects[nft_id] : null;
    let nft_md_id = nft_obj ? nft_obj.nft_metadata_id : null;
    let nft_md_obj =
        nft_md_id && nft_md_id in nft_full.objects ? nft_full.objects[nft_md_id] : null;

    // NFT and NFT_MD use URI fields as freeform data payloads. Try to extract if we can:
    let token_uri =
        'token_uri' in nft_obj ? parseJson(nft_full.objects[nft_id].token_uri) : default_token_uri;
    let base_uri =
        'base_uri' in nft_md_obj
            ? parseJson(nft_full.objects[nft_md_id].base_uri)
            : default_token_uri;

    //parse token_uri conditionally if it contains valid json
    let token_uri_json = !token_uri ? default_token_uri : token_uri;
    let base_uri_json = !base_uri ? default_token_uri : base_uri;

    //parse info
    let creator_id = nft_md_obj ? nft_md_obj.owner : null;
    let creator_acct_name = creator_id ? id_or_name(creator_id) : null;
    let creator_link = creator_id ? id_or_name_link(creator_id) : null;
    let creator_display = token_uri_json.created_by ? token_uri_json.created_by : creator_acct_name;
    let token_description = token_uri_json.description;
    let base_description = base_uri_json.description;

    //parse attributes conditionally if theyare present in token_uri.
    let attributes = token_uri_json.attributes ? token_uri_json.attributes : [];

    //dropdown collapse values
    let isDescriptionHidden = false;
    let isPropertiesHidden = false;
    let isAboutHidden = false;
</script>

<!-- Descriptive Widget -->
<div class="border rounded-md border-solid border-slate-300 divide-y divide-solid divide-slate-300">
    <!-- Description + owner/creator -->
    <div class="divide-y divide-solid divide-slate-300">
        <div class="py-4 px-5 ">
            <button
                type="button"
                class="w-full"
                class:active={isDescriptionHidden}
                on:click={() => (isDescriptionHidden = !isDescriptionHidden)}
            >
                <div class="flex justify-between items-center">
                    <div class="flex items-center space-x-4">
                        <div class="rounded-full bg-slate-300 w-5 h-5" />
                        <h4>Description</h4>
                    </div>
                    <div class="">
                        {#if isDescriptionHidden}
                            <span class="icon">&#9660;</span>
                        {:else}
                            <span class="icon">&#9650;</span>
                        {/if}
                    </div>
                </div>
            </button>
        </div>
        <div class="content px-6 py-8" class:hidden={isDescriptionHidden}>
            <h5 class="text-md pb-4">
                By
                <a
                    class="no-underline text-sky-500 decoration-0 break-all hover:text-sky-300"
                    href={'/u/' + creator_acct_name}
                >
                    {creator_display}
                </a>
            </h5>

            <p>{token_description}</p>
        </div>
    </div>

    <!-- properties  -->
    <div class="divide-y divide-solid divide-slate-300">
        <div class="py-4 px-5">
            <button
                type="button"
                class="w-full"
                class:active={isPropertiesHidden}
                on:click={() => (isPropertiesHidden = !isPropertiesHidden)}
            >
                <div class="flex justify-between items-center">
                    <div class="flex items-center space-x-4">
                        <div class="rounded-full bg-slate-300 w-5 h-5" />
                        <h4>Properties</h4>
                    </div>
                    <div class="">
                        {#if isPropertiesHidden}
                            <span class="icon">&#9660;</span>
                        {:else}
                            <span class="icon">&#9650;</span>
                        {/if}
                    </div>
                </div>
            </button>
        </div>

        <div
            class="content flex flex-wrap px-6 py-8 justify-start space-x-2"
            class:hidden={isPropertiesHidden}
        >
            {#if attributes.length > 0}
                {#each attributes as attribute}
                    <div class="px-8 py-8 text-center rounded-md bg-emerald-200 ">
                        <h4>{attribute.trait_type}</h4>
                        <h6 class="text-slate-500">{attribute.value}</h6>
                    </div>
                {/each}
            {:else}
                <div class="px-8 py-8 text-center rounded-md bg-emerald-200 ">
                    <h4>No traits to display</h4>
                </div>
            {/if}
        </div>
    </div>

    <!-- about -->
    <div class="divide-y divide-solid divide-slate-300">
        <div class="py-4 px-5">
            <button
                type="button"
                class="w-full"
                class:active={isAboutHidden}
                on:click={() => (isAboutHidden = !isAboutHidden)}
            >
                <div class="flex justify-between items-center">
                    <div class="flex items-center space-x-4">
                        <div class="rounded-full bg-slate-300 w-5 h-5" />
                        <h4>About</h4>
                    </div>
                    <div class="">
                        {#if isAboutHidden}
                            <span class="icon">&#9660;</span>
                        {:else}
                            <span class="icon">&#9650;</span>
                        {/if}
                    </div>
                </div>
            </button>
        </div>
        <div class="content px-6 py-10" class:hidden={isAboutHidden}>
            <p>{base_description}</p>
        </div>
    </div>
</div>

<style>
    h2 {
        font-size: 1.5em;
    }
    .testcase {
        background-color: LightGray;
        padding-left: 1em;
        padding-top: 0.5em;
        padding-bottom: 0.5em;
        margin-top: 1em;
        margin-bottom: 1em;
    }
    .collapsible {
        background-color: #f7f7f7;
        color: #444;
        cursor: pointer;
        padding: 10px;
        width: 100%;
        border: none;
        text-align: left;
        outline: none;
        font-size: 15px;
    }

    /* Style the collapsible content. Note: hidden by default */
    .content {
        transition: max-height 0.2s ease-out;
    }
</style>
